(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["nslauncher"] = factory();
	else
		root["nslauncher"] = factory();
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/api.js":
/*!********************!*\
  !*** ./src/api.js ***!
  \********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "transformCallback": () => (/* binding */ transformCallback),
/* harmony export */   "invoke": () => (/* binding */ invoke)
/* harmony export */ });
function uid() {
    const length = new Int8Array(1)
    window.crypto.getRandomValues(length)
    const array = new Uint8Array(Math.max(16, Math.abs(length[0])))
    window.crypto.getRandomValues(array)
    return array.join('')
}

function transformCallback(
    callback,
    once = false
) {
    const identifier = uid()

    Object.defineProperty(window, identifier, {
        value: (result) => {
            if (once) {
                Reflect.deleteProperty(window, identifier)
            }

            return callback?.(result)
        },
        writable: false,
        configurable: true
    })

    return identifier
}



async function invoke(args = {}) {
    return new Promise((resolve, reject) => {
        const callback = transformCallback((e) => {
            resolve(e)
            Reflect.deleteProperty(window, error)
        }, true)
        const error = transformCallback((e) => {
            reject(e)
            Reflect.deleteProperty(window, callback)
        }, true)
        window.rpc.notify('nslauncher', {
            callback,
            error,
            ...args
        })
    })
}



/***/ }),

/***/ "./src/event.js":
/*!**********************!*\
  !*** ./src/event.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "listen": () => (/* binding */ listen)
/* harmony export */ });
/* harmony import */ var _api__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api */ "./src/api.js");



async function listen(
    event,
    handler
) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Event',
        message: {
            cmd: 'listen',
            event,
            handler: (0,_api__WEBPACK_IMPORTED_MODULE_0__.transformCallback)(handler)
        }
    }).then((eventId) => {
        return async () => _unlisten(eventId)
    })
}

async function _unlisten(eventId) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Event',
        message: {
            cmd: 'unlisten',
            eventId
        }
    })
}



/***/ }),

/***/ "./src/launcher.js":
/*!*************************!*\
  !*** ./src/launcher.js ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ready": () => (/* binding */ ready),
/* harmony export */   "login": () => (/* binding */ login),
/* harmony export */   "logout": () => (/* binding */ logout),
/* harmony export */   "play": () => (/* binding */ play),
/* harmony export */   "selectGameDir": () => (/* binding */ selectGameDir),
/* harmony export */   "saveSettings": () => (/* binding */ saveSettings),
/* harmony export */   "sendMessage": () => (/* binding */ sendMessage)
/* harmony export */ });
/* harmony import */ var _api__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api */ "./src/api.js");



async function ready() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'ready'
        }
    })
}

async function login(username, password, rememberMe) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'login',
            username,
            password,
            rememberMe
        }
    })
}

async function logout() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'logout'
        }
    })
}

async function play(profile) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'play',
            profile
        }
    })
}

async function selectGameDir() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'selectGameDir',
        }
    })
}

async function saveSettings(settings) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'saveSettings',
            settings
        }
    })
}

async function sendMessage(message) {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Launcher',
        message: {
            cmd: 'sendCustomMessage',
            message: message
        }
    })
}



/***/ }),

/***/ "./src/library.js":
/*!************************!*\
  !*** ./src/library.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getLibrary": () => (/* binding */ getLibrary)
/* harmony export */ });
/* harmony import */ var _api__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api */ "./src/api.js");


async function getLibrary(library) {
    const libId = await (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Library',
        message: {
            "cmd": 'getLibrary',
            library
        }
    })
    return {
        invoke: async function (symbol, payload) {
            return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
                module: 'Library',
                message: {
                    "cmd": 'Invoke',
                    library: libId,
                    symbol,
                    payload
                }
            })
        }
    };
}



/***/ }),

/***/ "./src/system.js":
/*!***********************!*\
  !*** ./src/system.js ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getTotalRam": () => (/* binding */ getTotalRam)
/* harmony export */ });
/* harmony import */ var _api__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api */ "./src/api.js");



async function getTotalRam() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'System',
        message: {
            "cmd": 'getTotalRam'
        }
    })
}



/***/ }),

/***/ "./src/window.js":
/*!***********************!*\
  !*** ./src/window.js ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "hide": () => (/* binding */ hide),
/* harmony export */   "show": () => (/* binding */ show),
/* harmony export */   "exit": () => (/* binding */ exit)
/* harmony export */ });
/* harmony import */ var _api__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./api */ "./src/api.js");


async function hide() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Window',
        message: {
            "cmd": 'hide'
        }
    })
}

async function show() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Window',
        message: {
            "cmd": 'show'
        }
    })
}

async function exit() {
    return (0,_api__WEBPACK_IMPORTED_MODULE_0__.invoke)({
        module: 'Window',
        message: {
            "cmd": 'exit'
        }
    })
}




/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "window": () => (/* reexport module object */ _window__WEBPACK_IMPORTED_MODULE_0__),
/* harmony export */   "launcher": () => (/* reexport module object */ _launcher__WEBPACK_IMPORTED_MODULE_1__),
/* harmony export */   "event": () => (/* reexport module object */ _event__WEBPACK_IMPORTED_MODULE_2__),
/* harmony export */   "library": () => (/* reexport module object */ _library__WEBPACK_IMPORTED_MODULE_3__),
/* harmony export */   "system": () => (/* reexport module object */ _system__WEBPACK_IMPORTED_MODULE_4__)
/* harmony export */ });
/* harmony import */ var _window__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./window */ "./src/window.js");
/* harmony import */ var _launcher__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./launcher */ "./src/launcher.js");
/* harmony import */ var _event__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./event */ "./src/event.js");
/* harmony import */ var _library__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./library */ "./src/library.js");
/* harmony import */ var _system__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./system */ "./src/system.js");







})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=nslauncher-runtime-api.js.map